#include "cluster.hpp"

namespace Clustering{

//
// Dump a point
//
  std::ostream& operator << (std::ostream& os, const Point& p){
    
    BOOST_FOREACH(Point::value_type d, p){ os << d << " "; }    
	os << std::endl;
    return os;
  };

//
// distance between two points
//
  Distance dist(const Point & x, const Point & y)
  {
    Distance total = 0.0;
    Distance diff;
    
	Point::const_iterator cpx=x.begin(); 
	Point::const_iterator cpy=y.begin();
	Point::const_iterator cpx_end=x.end();
    for(;cpx!=cpx_end;++cpx,++cpy){
		  diff = *cpx - *cpy;
	      total += (diff * diff); 
	}
    return total;  // no need to take sqrt, which is monotonic
  };

//
// Dump collection of Points
//
  std::ostream& operator << (std::ostream& os, Points& cps){
    BOOST_FOREACH(Points::value_type p, cps){ os<<p;}
	os << "end points" << std::endl;
    return os;
  };

//
// Dump Assignement
//
  std::ostream& operator << (std::ostream& os, Assignement& as){
	IDPoint pid = 0;	
	BOOST_FOREACH(Assignement::value_type a, as){ 
		os << "Point id " << pid << "--> cid=" << a.first << " Distance from centroid=" << a.second;
		os<<std::endl;
		pid++;
	}
    return os;
  }

//
// Init collection of points
//  
  void Space::init_points() { 

	  __points.resize(__num_points);						// Space has __num_points

	  BOOST_FOREACH(Points::value_type &p, __points){       // each point

		  p.resize(__num_dimensions);                       // has _num_dimension

		  for (Dimensions d=0 ; d < __num_dimensions; d++)  // earch dimension is initialized
			p[d] = static_cast<double> (rand() % 100);
	  }
  };

//
// Dump Space
// 
	std::ostream& operator << (std::ostream& os, Space& s){
	   BOOST_FOREACH(Points::value_type point, s.points()){ os<< point <<std::endl;}
		return os;
	};



};